#include "DynamicConfiguration.h"
#include "Logging.h"
#include <sstream>

DynamicConfiguration::DynamicConfiguration(AgentManager *am, Acd *acd)
{
    mAgentManager = am;
    mAcd = acd;
}

DynamicConfiguration::~DynamicConfiguration(){
}

void DynamicConfiguration::loadScript(std::string filename)
{
    char buf[255];
    FILE *f = fopen(filename.c_str(),"r");
    if (f)
    {
        while (fgets((char*)&buf,255,f))
        {
            std::string line = ((char*)&buf);
            this->processCommand(line);
        }
    }
}
void DynamicConfiguration::processCommand(std::string cmd)
{
    std::istringstream iss(cmd, std::istringstream::in);
    std::string word;
    std::string words[10];
    int i=0;
    while( iss >> word && i<10)     
    {
        words[i]=word;
        i++;
    }
    
    if (words[0]=="queue"){
        Logging::log("Creating queue '%s'\r\n",words[1].c_str());
        Queue *q = mAcd->createQueue(words[1]);
        q->setAnnouncement(words[2],words[3],words[4],atoi(words[5].c_str()));
    } else if (words[0]=="agent"){
        Logging::log("Creating agent '%s'\r\n",words[1].c_str());
        Agent * agent = new Agent(words[1]);
        mAgentManager->addAgent(agent);

    } else if (words[0]=="add"){
        Queue *q = mAcd->getQueue(words[2]);
        Agent *a = mAgentManager->getAgent(words[1]);
        if (a && q)
        {
            Logging::log("Adding '%s' in queue '%s'\r\n",words[1].c_str(),words[2].c_str());
            a->setMemberOf(q);
        }
    }
    
}

