#include "HTTPRequest.h"
#include <sstream>
#include <regex.h>
#include "pcre.h"

HTTPRequest::HTTPRequest(std::string request)
{

    regmatch_t matches[20];
    regex_t re;
    regcomp(&re,"GET /(.*)\\?*(.*) HTTP",REG_EXTENDED); //TODO: how to find repeating groups?? we could avoid doing the rest manually. Maybe with pcre it would be possible
    int err = regexec(&re,request.c_str(),20,matches,0);
    if (!err)
    {
        int i=0;
        mRequest = request.substr(matches[1].rm_so,(matches[1].rm_eo-matches[1].rm_so));
        std::string params = request.substr(matches[2].rm_so,(matches[2].rm_eo-matches[2].rm_so));

        params+="&";
        const char *p = params.c_str();
        int s = params.size();
        i=0;
        int n=0;
        char key[s];
        char val[s];
        char *buf=(char*)&key;
        while (i<s)
        {
            char c = p[i];
            if (c=='&' || c=='=')
            {
                buf[n]=0;
                if (c=='=') buf = (char*)&val;
                if (c=='&')
                {
                    buf = (char*)&key;
                    mParams[(char*)&key] = (char*)&val;
                }
                n=0;
            } else {
                buf[n]=c;
                n++;
            }
            i++;
        }
    }

    regfree(&re);
}

HTTPRequest::~HTTPRequest(){
}

std::string HTTPRequest::getRequest()
{
    return mRequest;
}

std::string HTTPRequest::getParam(std::string param)
{
    if (mParams.find(param)!=mParams.end()) return mParams[param];
    return "";
}

