#include "Logging.h"
#include "MIAQueue.h"

MIAQueue::MIAQueue(std::string queueName, CallManager* callManager):Queue(queueName,callManager){
}

MIAQueue::~MIAQueue(){
}


void MIAQueue::routeOneCall(AgentManager *am)
{
    Agent *agent = am->getMostIdleAgentForQueue(this);

    if (agent)
    {
       Call *call = this->getFirstCall();
       if (call)
       {
           Call *call2 = mCallManager->call(agent->getContact(),this->getName());
           if (call2)
           {
               call2->assignCall(call,agent);
               Logging::log("Found call %s to send to agent %s\r\n",call->getID().c_str(),agent->getUserName().c_str());
           }
        }
    }
}
