#ifndef QUEUE_H
#define QUEUE_H

#include <string>
#include "CallManager.h"
#include "CallObserver.h"
#include "AgentManager.h"
#include <list>
#include "JSON.h"
#include <resip/dum/AppDialogSet.hxx>

class Queue: public CallObserver{
private:

protected:
    std::string mQueueName;
    CallManager *mCallManager;
    std::list<resip::AppDialogSetHandle> mCallList;
    Call *getFirstCall();    
    std::string mQueueMusic;
    std::string mWelcome;
    std::string mAnnouncement;
    int mAnnouncementInterval;


public:
	Queue(std::string queueName, CallManager *callManager);
	~Queue();


    void onCallTerminated(Call *call);
    void onCallAnswered(Call *call);
    void onCallFailed(Call *call);
    void onRONA(Call *call);
    void onIncommingCallAnswered(Call *call);
    void onIncommingCall(Call *call);
    void onDTMF(Call *call,std::string digit);

    virtual void routeOneCall(AgentManager *am)=0;

    void setAnnouncement(std::string music, std::string welcome, std::string announce, int interval);
    std::string getName();
    void toJSON(Dumais::JSON::JSON& json);


};

#endif

